using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Demo2
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();
		}
		DataSet ds = new DataSet();
		DataSet dsSchema = new DataSet();
		string FileName;
		private void button1_Click(object sender, EventArgs e)
		{
			this.Text = "";
			int startTick = System.Environment.TickCount;
			ds.ReadXml("\\dataandschema.xml");
			int endTick = System.Environment.TickCount;
			int i = endTick - startTick;
			this.Text = this.Text + i.ToString();

			//startTick = System.Environment.TickCount;
			//dsSchema.ReadXmlSchema(FileName);
			//endTick = System.Environment.TickCount;
			//i = endTick - startTick;
			//this.Text = this.Text + "   " + i.ToString();
		}
		private string GetXMLFileName()
		{
			return System.IO.Path.Combine(System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase), "TrainsInfo.xml");
		}

		private void Form1_Load(object sender, EventArgs e)
		{
			FileName = this.GetXMLFileName();
		}

		private void button3_Click(object sender, EventArgs e)
		{
			this.textBox1.Text = this.textBox1.Text.Trim();
			if (this.textBox1.Text.Length == 0)
				return;

			ds.Tables["Train"].DefaultView.RowFilter = "Name='" + this.textBox1.Text + "'";
			if (ds.Tables["Train"].DefaultView.Count==1)
			{
				this.listView1.Items.Clear();
				int startTick = System.Environment.TickCount;

				DataRowView drv = ds.Tables["Train"].DefaultView[0];
				DataRow originalRow = drv.Row;
				DataRow[] dvs =  originalRow.GetChildRows(ds.Relations[0]);
				foreach (DataRow dr in dvs)
				{
					this.listView1.BeginUpdate();
					ListViewItem lvi = new ListViewItem(dr["Sequence"].ToString());
					lvi.SubItems.Add(dr["Name"].ToString());
					lvi.SubItems.Add(dr["ArriveTime"].ToString());
					lvi.SubItems.Add(dr["LeaveTime"].ToString());
					lvi.SubItems.Add(dr["TravelTime"].ToString());
					lvi.SubItems.Add(dr["TravelDistance"].ToString());
					this.listView1.Items.Add(lvi);
					this.listView1.EndUpdate();
				}
				int endTick = System.Environment.TickCount;
				int i = endTick - startTick;
				this.Text = i.ToString();
			}
		}

		private void button2_Click(object sender, EventArgs e)
		{
			ds.WriteXml("\\data.xml", XmlWriteMode.IgnoreSchema);
			ds.WriteXml("\\dataandschema.xml", XmlWriteMode.WriteSchema);
			ds.WriteXmlSchema("\\schema.xml");
		}
	}
}